diff -Naur adduser-3.112+nmu1.orig/adduser adduser-3.112+nmu1/adduser
--- adduser-3.112+nmu1.orig/adduser	2009-09-21 00:31:46.000000000 +0400
+++ adduser-3.112+nmu1/adduser	2010-11-22 22:36:31.787591472 +0300
@@ -66,19 +66,37 @@
     }
     eval {
 	require I18N::Langinfo;
-	import I18N::Langinfo qw(langinfo YESEXPR NOEXPR);
+	import I18N::Langinfo qw(langinfo CODESET YESEXPR NOEXPR);
     };
     if ($@) {
 	*langinfo = sub { return shift; };
 	*YESEXPR  = sub { "^[yY]" };
 	*NOEXPR   = sub { "^[nN]" };
+	*CODESET  = sub { "" };
+    } else {
+	    # idea from /usr/share/perl5/Debconf/Encoding.pm
+	    no warnings;
+	    eval q{ use Text::Iconv };
+	    use warnings;
+	    if (! $@) {
+		*decode = sub {
+			my $string = shift;
+			my $converter = Text::Iconv->new(langinfo(CODESET()), "UTF-8");
+			$string = $converter->convert($string);
+			utf8::decode($string);
+			return $string;
+		}
+	   };
+    };
+    if (! defined(&decode)) {
+	*decode  = sub { return shift; };
     }
 }
 
 setlocale(LC_MESSAGES, "");
 textdomain("adduser");
-my $yesexpr = langinfo(YESEXPR());
 
+my $yesexpr = decode(langinfo(YESEXPR()));
 my %config;			# configuration hash
 
 my @defaults = ("/etc/adduser.conf");
@@ -531,7 +549,7 @@
     create_homedir (1); # copy skeleton data
 
     # useradd without -p has left the account disabled (password string is '!')
-    my $yesexpr = langinfo(YESEXPR());
+    my $yesexpr = decode(langinfo(YESEXPR()));
     if ($ask_passwd) {
 	for (;;) {
           my $passwd = &which('passwd');
@@ -554,6 +572,7 @@
 	    # expression will be checked to find positive answer.
 	    print (gtx("Try again? [y/N] "));
 	    chop ($answer=<STDIN>);
+	    $answer = decode($answer);
 	    last if ($answer !~ m/$yesexpr/o);
 	  }
 	  else {
@@ -571,7 +590,7 @@
 	&ch_gecos($new_gecos);
     }
     else {
-	my $noexpr = langinfo(NOEXPR());
+	my $noexpr = decode(langinfo(NOEXPR()));
 	for (;;) {
            my $chfn = &which('chfn');
 	    &systemcall($chfn, $new_name);
@@ -580,6 +599,7 @@
 	    # expression will be checked to find positive answer.
 	    print (gtx("Is the information correct? [Y/n] "));
 	    chop (my $answer=<STDIN>);
+	    $answer = decode($answer);
 	    last if ($answer !~ m/$noexpr/o);
 	}
     }
